#include "header.h"

// Nombre de possibilités positifs => plusieurs possibilités

// Calcule le nombre de possibilités sur une case
// Entrée : - matrice de cases sudoku
//          - case pour laquelle il faut faire le calcul
// Pré-condition : case non nulle
// Sortie : - entier nbPos contenant le nombre de possibilités
// Post-condition : nbPos positif ou nul
// Non testée
int nombrePossibilites(cases** sudoku, cases cellule) {
  // Déclaration des variables

  // taille de la matrice
  int n = sizeof(sudoku[0]) / sizeof(cases); 

  //Variable renvoyee
  int nbPoss;
  
  // poss contient les entier de 1 à n²
  // à chaque fois qu'un nombre n'est pas valide on le remplace par 0
  int* poss = malloc(sizeof(int) * n * n);
  
  int x = cellule.coordonnees.x;
  int y = cellule.coordonnees.y;

  //Remplissage de la liste de possiblilites
  for (int i = 0; i < n * n; i++) {
    poss[i] = i + 1;
  }
  
  // Vérification sur la ligne
  for (int j = 0; j < n * n; j++) {
	if (sudoku[x][j].valeur != 0) {
      poss[sudoku[x][j].valeur - 1] = 0;
    }
  }
  
  // Vérification sur la colonne
  for (int i = 0; i < n * n; i++) {
    if (sudoku[i][y].valeur != 0) {
      poss[sudoku[i][y].valeur - 1] = 0;
    }
  }
  
  // Vérification dans le grand carré de taille n :
  
  // Retrouve l'abscice du grand carré
  int ex = x / n;
  // Retrouve l'abcsice de la cellule dans le grand garré
  int rx = x % n;
  // Retrouve l'ordonnée du grand carré
  int ey = y / n;
  // Retrouve l'ordonnée de la cellule dans le grand garré
  int ry = y % n;

  //Boucle de parcours du grand carre
  for (int i = 0; i < n; i++)
  {
    for (int j = 0; j < n)
      if (sudoku[i + ex*n][y + ey*n].valeur != 0)
      {
        poss[sudoku[i + ex*n][y + ey*n].valeur - 1] = 0;
      }
  }
  
  //Parcours de la liste de possiblites pour obtenir le nombre de possibilites
  for (int k = 0; k < n*n; k++)
  {
    if (poss[k] != 0)
    {
       nbPoss++;
    }
  }
  
  return nbPoss;
}

// Verification de la validité d'une cellule
// Entrée : - Sudoku
//          - Cellule à vérifier
// Sortie : - Booléen : - true si la cellule est valide
//                      - false sinon
// Pré-condition : la cellule fait partie de la grille de Sudoku
// Non testée
bool estValide(cases **sudoku, cases cellule) {
  return nombrePossibilites(sudoku, cellule) != 0;
}

