// DIRECTIVES PRE-PROCESSEUR
#include <assert.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

// DÉFINITION DES STRUCTURES

// Couple de coordonnées
typedef struct {
  unsigned int x;
  unsigned int y;
} couple;

// Structure associée à chaque case de la grille
typedef struct {
  int possibilites;
  unsigned int valeur;
  couple coordonnees;
} cases;

// Noeud de la liste chainee
typedef struct str_noeud {
  cases carre;
  struct str_noeud* suivant;
  struct str_noeud* precedent;
} noeud;

// Liste chaînée
typedef struct tete_liste {
  noeud* premierElement;
  int longueur;
} listeChainee;

// PROTOTYPES

// Fonctions sudoku
int nombrePossibilites(cases** sudoku, cases cellule, int n);
bool estValide(cases** sudoku, cases cellule, int n);
void remplirPoss(cases** sudoku, int n);
void afficheSudoku(cases** sudoku, int n);
void remplitSudoku(cases** grille, listeChainee liste, int n);

// Fonctions listes chaînées
noeud* tri(listeChainee* liste);
void remplirListe(listeChainee* liste, noeud* actuel, cases** grille, int ligne, int colonne, int n);
noeud* creeNoeud(cases cellule);
void echange(noeud* a, noeud* b, noeud* parentA);
