#include "header.h"

int main() {
  int n = 3;
  cases** grille = (cases**)malloc(n * n * sizeof(cases*));
  assert(grille != NULL);

  for (int i = 0; i < n * n; i++) {
    cases* cellule = (cases*)malloc(n * n * sizeof(cases));
    assert(cellule != NULL);
    grille[i] = cellule;
  }

  // intitalisation du sudoku avec toutes les valeurs nulles
  for (int i = 0; i < n * n; i++) {
    for (int j = 0; j < n * n; j++) {
      grille[i][j].valeur = 0;
      grille[i][j].coordonnees.x = i;
      grille[i][j].coordonnees.y = j;
      grille[i][j].possibilites = 0;
    }
  }

  grille[0][1].valeur = 2;
  grille[1][1].valeur = 8;
  grille[1][5].valeur = 7;
  grille[1][6].valeur = 4;
  grille[1][8].valeur = 6;
  grille[2][0].valeur = 4;
  grille[2][1].valeur = 9;
  grille[2][2].valeur = 1;
  grille[2][6].valeur = 8;
  grille[2][8].valeur = 3;
  grille[3][4].valeur = 3;
  grille[3][5].valeur = 9;
  grille[3][7].valeur = 5;
  grille[3][8].valeur = 7;
  grille[4][0].valeur = 8;
  grille[4][4].valeur = 1;
  grille[4][7].valeur = 4;
  grille[4][8].valeur = 2;
  grille[5][0].valeur = 3;
  grille[5][2].valeur = 5;
  grille[5][3].valeur = 2;
  grille[5][5].valeur = 6;
  grille[5][8].valeur = 9;
  grille[6][0].valeur = 7;
  grille[6][1].valeur = 5;
  grille[6][2].valeur = 4;
  grille[7][6].valeur = 7;
  grille[7][7].valeur = 1;
  grille[8][1].valeur = 1;
  grille[8][2].valeur = 6;
  grille[8][3].valeur = 5;
  grille[8][6].valeur = 2;
  grille[8][8].valeur = 4;

  // on ajoute le nombre de possibilités de chaque cellule à l'enregistrement
  remplirPoss(grille, n);

  listeChainee liste = {NULL, 0};
  int indice_i = 0;
  int indice_j = 0;
  noeud *noeudActif = liste.premierElement;
  for (int i = 0; i < n * n; i++) {
    for (int j = 0; j < n * n; j++) {
      if (grille[i][j].valeur == 0) {
        // on crée les nœuds avec des cases vides pour l'ajouter
        // à la liste chaînée

        noeud *nouveauNoeud = creeNoeud(grille[i][j]);

        if (liste.premierElement == NULL) {
          noeudActif = nouveauNoeud;
          liste.premierElement = noeudActif;
        } else {
          noeudActif->suivant = nouveauNoeud;
        }

        liste.longueur++;

        if (j < n * n - 1) {
          indice_i = i;
          indice_j = j + 1;
        } else {
          indice_i = i + 1;
          indice_j = 0;
        }
        i = n * n;
        j = n * n;
      }
    }
  }

  remplirListe(&liste, liste.premierElement, grille, indice_i, indice_j, n);
  tri(&liste);

  printf("Grille de depart\n");
  afficheSudoku(grille, n);
  printf("-------\n");
  remplitSudoku(grille, liste, n);
  printf("\nGrille resolue\n");
  afficheSudoku(grille, n);

  return 0;
}